Author: Dawid Adach
Currently, our Event component displays an icon that is supposed to delete the item from the list. As you already know, the list of the Events is held in the parent component - App. Therefore, it's not possible for the Event component to delete itself.
In order to delete an event from a list, we have to pass a call from the child component (Event) to its parent component (App). In this lesson, we will learn how to pass function calls between components.
Before we start to that, let's work on App template first:
1. App template
1.1. Style
We don't need styles anymore, so let's remove them from both of the App.vue
and Event.vue
files.
1.2. Template
Let's update the template of our app:
<template>
<mdb-container>
<mdb-row>
<mdb-col col="9">
<h2 class="text-uppercase my-3">Today:</h2>
<Event
v-for="(event, index) in events"
:index="index"
:time="event.time"
:title="event.title"
:location="event.location"
:description="event.description"
:key="index"
/>
<mdb-row>
<mdb-col xl="3" md="6" class="mx-auto text-center">
<mdb-btn color="info">Add Event</mdb-btn>
</mdb-col>
</mdb-row>
</mdb-col>
<mdb-col col="3">
<h3 class="text-uppercase my-3">Schedule</h3>
<h6 class="my-3">
It's going to be busy that today. You have
<b>{{events.length}} events</b> today.
</h6>
<h1 class="my-3">
<mdb-row>
<mdb-col col="3" class="text-center">
<mdb-icon far icon="sun"/>
</mdb-col>
<mdb-col col="9">Sunny</mdb-col>
</mdb-row>
<mdb-row>
<mdb-col col="3" class="text-center">
<mdb-icon icon="thermometer-three-quarters"/>
</mdb-col>
<mdb-col col="9">23°C</mdb-col>
</mdb-row>
</h1>
<p>
Don't forget your sunglasses. Today will dry and sunny, becoming
warm in the afternoon with temperatures of between 20 and 25
degrees.
</p>
</mdb-col>
</mdb-row>
</mdb-container>
</template>
1.3. Script
Finally, let's import some missing components like mdbButton and mdbIcon from the library:
import { mdbContainer, mdbRow, mdbCol, mdbIcon, mdbBtn, } from "mdbvue";
[...]
components: {
mdbContainer,
mdbRow,
mdbCol,
Event,
mdbIcon,
mdbBtn,
},
Preview:

Note:
In the right-hand column, we added an Event counter which tells us how many events are scheduled for today. In order to get this number we are simply counting elements within the array using {{events.length}} function.
2. Delete Event function
Now we can create a function which removes a particular Event from an array. It's a very simple function which accepts the id of the event which we want to delete, and remove it from the array[] using the splice() function:
handleDelete(eventIndex) {
this.events.splice(eventIndex, 1);
}
export default {
name: "App",
components: {
[...]
},
data() {
[...]
},
methods: {
handleDelete(eventIndex) {
this.events.splice(eventIndex, 1);
}
}
};
Now when our function is ready, we can emit an event from the Event component.
3. Event emitting
Let's define an event handler for our Event component:
methods: {
onDelete() {
this.$emit('delete', this.index);
}
}
This function will emit an event with two parameters:
- name of the event - in our case delete
- payload - in our case it will be the id of the corresponding Event
Now we have to trigger it whenever users click on the delete icon. Let's therefore update our existing: <mdb-badge> tag.
<mdb-badge tag="a" color="danger-color" class="ml-2 float-right">-</mdb-badge>
with a @click.native function call.
<mdb-badge @click.native="onDelete" tag="a" color="danger-color" class="ml-2 float-right">-</mdb-badge>
Now whenever a user clicks on the delete icon, next to the Event title, it will emit a new delete event with the id of the clicked Event.
4. Catching & handling events
The last thing we have to do is to catch the emitted event in App.ve
. In order to do that, let's update our Event invocation within App template:
<Event
v-for="(event, index) in events"
:index="index"
:time="event.time"
:title="event.title"
:location="event.location"
:description="event.description"
:key="index"
@delete="handleDelete"
/>
As you noticed, we have added a @delete handle and bound it to the handleDelete function which created in step 2.

Now, whenever we click on a delete icon:
- User clicks on the delete icon
- @click.native calls the onDelete() function
- onDelete() emits an event
- The App component catches it and triggers handleDelete()
- handleDelete() deletes the corresponding element from the array

Finally, Vue automatically notices that the data model has changed and re-renders the list of events.
Previous lesson Download Next lesson
Spread the word:


Author: Dawid Adach
Currently, our Event component displays an icon that is supposed to delete the item from the list. As you already know, the list of the Events is held in the parent component - App. Therefore, it's not possible for the Event component to delete itself.
In order to delete an event from a list, we have to pass a call from the child component (Event) to its parent component (App). In this lesson, we will learn how to pass function calls between components.
Before we start to that, let's work on App template first:
1. App template
1.1. Style
We don't need styles anymore, let's remove them from app.component.scss
.
1.2. Template
Update app.component.html
file with the following template:
<div class="container">
<div class="row mt-3">
<div class="col-md-9">
<div *ngFor="let event of events">
<app-event [value]="event"></app-event>
</div>
<div class="text-center">
<a
type="button"
mdbBtn
color="info"
class="waves-effect mb-4"
mdbWavesEffect
>Add event
</a>
</div>
</div>
<div class="col-md-3">
<h3 class="text-uppercase my-3">Schedule</h3>
<h6 class="my-3">
It's going to be busy that today. You have
<b> {{ events.length }} events </b> today.
</h6>
<h1 class="my-3">
<div class="row">
<div class="col-3 text-center">
<mdb-icon fas icon="sun"></mdb-icon>
</div>
<div class="col-9 ">Sunny</div>
</div>
<div class="row">
<div class="col-3 text-center">
<mdb-icon fas icon="thermometer-three-quarters"></mdb-icon>
</div>
<div class="col-3 ">23°C</div>
</div>
</h1>
<p>
Don't forget your sunglasses. Today will dry and sunny, becoming warm
in the afternoon with temperatures of between 20 and 25 degrees.
</p>
</div>
</div>
</div>
List of changes:
- Added "Add event" button
- Added event counter ({{ events.length }}) in the right column
- Added static (Weather Forecast) content to the right column
- Added some minor classes to enhance spacing
Preview:

Note:
In the right-hand column, we added an Event counter which tells us how many events are scheduled for today. In order to get this number we are simply counting elements within the array using {{events.length}} function.
2. Delete Event function
Now we can create a function which removes a particular Event from an array. It's a very simple function, it looks for index of clicked item, and remove it from the events array[] using splice() function.
Add following function to AppComponent class within the app.component.ts
file
deleteEvent(event: any) {
const itemIndex = this.events.findIndex(el => el === event);
this.events.splice(itemIndex, 1);
}
Note:
findIndex() method returns the index of the first element in the array that satisfies the provided testing function. In our case we are checking whether item (event) which we are about to delete is one of the items (el) in the array, and returns it's position.
Now when our function is ready, we can emit and event from Event component.
3. Handle click event
- Add new function to EventComponent class within the
event.component.ts
file. - Update the mdb-badge in
event.component.html
- Test it. Run the app, open developers console and click on the delete icon. You should see confrimation message in a console.
handleDeleteClick() {
console.log("Delete button clicked!");
}
<mdb-badge (click)="handleDeleteClick()" danger="true" class="text-center float-right">-</mdb-badge>

4. Event emitting
In order to call the parent (App) component's deleteEvent() function from child (Event) component we have to emit an Event
from one component and catch it other.
Warning:
The naming might be a little bit confusing. This is because we have component within our app which we called an Event. This Event represents a single entry in our agenda (we could have called it Item, Appointment or Entry).
At the same time Angular uses Event
to call JavaScript-like events. This Event
reffers to "occurrence" on which JavaScript can react.
Since this may be a bit confusing I will use different styles and whenever we will reffer to Event Component i will use yellow highligt, while whenever I will referr to Angular Event
I will use a red font.
Whenever we want to emit an Event
, we have to import EventEmmiter first. Since we will transfer outside the component, we also have to import Output
directive.
- Import
EventEmmiter
andOutput
inevent.components.ts
- Define the
@Output()
within EventComponent class. - Update the handleDeleteClick() method with the following code:
<mdb-badge (click)="handleDeleteClick()" danger="true" class="text-center float-right">-</mdb-badge>
Note:
In a previous lessons we were passing data to (inside) our component, in order to do that we had to use Input
directive.
Now, since we are passing data out (otuside) of our component, we have to use Output
directive.
@Output() deleteEventInstanceEvent: EventEmitter<any> = new EventEmitter<any>();
Note:
We called Output deleteEventInstanceEvent to make it clear that we are emitting and Event
to delete instance of Event.
You can read the name as deleteEventInstanceEvent
().
If we would call our calendar entry differently, i.e. Appointment, we could simply call this function deleteAppointmentEvent without ussing extra Instance word.
handleDeleteClick() {
this.deleteEventInstanceEvent.emit(this.value);
}
That how your event.component.ts
file should looks like:
import {Component, EventEmitter, Input, Output} from '@angular/core';
@Component({
selector: 'app-event',
templateUrl: './event.component.html',
})
export class EventComponent {
@Input() value: any;
@Output() deleteEventInstanceEvent: EventEmitter<any> = new EventEmitter<any>();
handleDeleteClick() {
this.deleteEventInstanceEvent.emit(this.value);
}
}
Now whenever user click on the delete icon, next to the Event title, it will emit a new event
and pass itself (an object) as a parameter.
4. Catching & handling events
The last thing we have to do is to catch emmited event
from the Event component.
In order to that let's update our <app-event> tag in app.component.html
:
<app-event [value]="event" (deleteEventInstanceEvent)="deleteEvent($event)"></app-event>
As you probably guessed, we have binded here emitted event
(deleteEventInstanceEvent) with the internal App component's function - deleteEvent() and we are passing.
In other words - we are telling Angular that he can expect that <app-event>
can emmit events
and which function do we want to use to handle it.

Now, whenever we click on a delete icon:
- User clicks on the delete icon
- (click) calls handleDeleteClick() function
- handleDeleteClick() emits deleteEventInstanceEvent
event
- App component catches it and triggers deleteEvent()
- deleteEvent() deletes corresponding element from the array

Previous lesson Next lesson
Spread the word:
